Bug 630283 - Review Request: ghc-neither - Either with monad and applicative instances
Review Request: ghc-neither - Either with monad and applicative instances
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Narasimhan
Fedora Extras Quality Assurance
:
Depends On: 630223 630270
Blocks:
  Show dependency treegraph
 
Reported: 2010-09-04 12:22 EDT by Ben Boeckel
Modified: 2012-02-07 04:45 EST (History)
4 users (show)

See Also:
Fixed In Version: ghc-neither-0.1.0-1.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-01-03 15:01:58 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
lakshminaras2002: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Ben Boeckel 2010-09-04 12:22:09 EDT
Spec URL: http://benboeckel.net/packaging/ghc-neither/ghc-neither.spec
SRPM URL: http://benboeckel.net/packaging/ghc-neither/ghc-neither-0.0.2-1.fc14.src.rpm
Description:
The standard Either datatype suffers from a lack of monad and
applicative instances. To make matters worse, the mtl and
transformers packages provide orphan instances which conflict
with each other, as well as defining a transformer version
which has an usually unnecessary superclass constraint.

Besides these annoyances, there is another issue: there exist
two reasonable definitions of the Applicative instance for
Either: one the holds onto only the first Left value, or one
that appends all Left values together via a Monoid instance.
The former is compatible with the monad instance, while the
latter is not.

This package defines three datatypes, some helpers functions
and instances. The data types are AEither, MEither and
MEitherT. AEither provides an Applicative instance which
appends Left values, MEither provides the monadic definition,
and MEitherT is a monad transformer.

% lintmock fedora-14-x86_64-bb
ghc-neither.src: W: spelling-error %description -l en_US datatype -> data type, data-type, database
ghc-neither.src: W: spelling-error %description -l en_US mtl -> mt, ml, mel
ghc-neither.src: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
ghc-neither.src: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
ghc-neither.src: W: strange-permission neither-0.0.2.tar.gz 0640L
ghc-neither.src: W: strange-permission ghc-neither.spec 0640L
ghc-neither.x86_64: W: spelling-error %description -l en_US datatype -> data type, data-type, database
ghc-neither.x86_64: W: spelling-error %description -l en_US mtl -> mt, ml, mel
ghc-neither.x86_64: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
ghc-neither.x86_64: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
ghc-neither-devel.x86_64: W: spelling-error %description -l en_US datatype -> data type, data-type, database
ghc-neither-devel.x86_64: W: spelling-error %description -l en_US mtl -> mt, ml, mel
ghc-neither-devel.x86_64: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
ghc-neither-devel.x86_64: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
ghc-neither-prof.x86_64: E: devel-dependency ghc-neither-devel
ghc-neither-prof.x86_64: W: spelling-error %description -l en_US datatype -> data type, data-type, database
ghc-neither-prof.x86_64: W: spelling-error %description -l en_US mtl -> mt, ml, mel
ghc-neither-prof.x86_64: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
ghc-neither-prof.x86_64: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
ghc-neither-prof.x86_64: W: no-documentation
ghc-neither-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.12.3/neither-0.0.2/libHSneither-0.0.2_p.a
4 packages and 0 specfiles checked; 1 errors, 20 warnings.
Comment 1 Ben Boeckel 2010-10-30 15:58:29 EDT
Update bug dependencies for new version.
Comment 2 Ben Boeckel 2010-10-31 12:34:13 EDT
Spec URL: http://benboeckel.net/packaging/ghc-neither/ghc-neither.spec
SRPM URL: http://benboeckel.net/packaging/ghc-neither/ghc-neither-0.1.0-1.fc14.src.rpm

% lintmock fedora-14-x86_64-bb
ghc-neither.src: W: spelling-error %description -l en_US datatype -> data type, data-type, database
ghc-neither.src: W: spelling-error %description -l en_US mtl -> mt, ml, mel
ghc-neither.src: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
ghc-neither.src: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
ghc-neither.src: W: strange-permission ghc-neither.spec 0640L
ghc-neither.src: W: strange-permission neither-0.1.0.tar.gz 0640L
ghc-neither.x86_64: W: spelling-error %description -l en_US datatype -> data type, data-type, database
ghc-neither.x86_64: W: spelling-error %description -l en_US mtl -> mt, ml, mel
ghc-neither.x86_64: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
ghc-neither.x86_64: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
ghc-neither-devel.x86_64: W: spelling-error %description -l en_US datatype -> data type, data-type, database
ghc-neither-devel.x86_64: W: spelling-error %description -l en_US mtl -> mt, ml, mel
ghc-neither-devel.x86_64: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
ghc-neither-devel.x86_64: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
ghc-neither-prof.x86_64: E: devel-dependency ghc-neither-devel
ghc-neither-prof.x86_64: W: spelling-error %description -l en_US datatype -> data type, data-type, database
ghc-neither-prof.x86_64: W: spelling-error %description -l en_US mtl -> mt, ml, mel
ghc-neither-prof.x86_64: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
ghc-neither-prof.x86_64: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
ghc-neither-prof.x86_64: W: no-documentation
ghc-neither-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.12.3/neither-0.1.0/libHSneither-0.1.0_p.a
4 packages and 0 specfiles checked; 1 errors, 20 warnings.
Comment 3 Narasimhan 2010-11-21 11:18:59 EST
[+]MUST: rpmlint must be run on every package. The output should be posted in the review.

rpmlint  -i ghc-neither-* ../../SRPMS/ghc-neither-0.1.0-1.fc14.src.rpm ~/ghc-neither.spec 
ghc-neither.x86_64: W: spelling-error %description -l en_US datatype -> data type, data-type, database
The value of this tag appears to be misspelled. Please double-check.

ghc-neither.x86_64: W: spelling-error %description -l en_US mtl -> mt, ml, mel
The value of this tag appears to be misspelled. Please double-check.

ghc-neither.x86_64: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
The value of this tag appears to be misspelled. Please double-check.

ghc-neither.x86_64: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
The value of this tag appears to be misspelled. Please double-check.

ghc-neither-devel.x86_64: W: spelling-error %description -l en_US datatype -> data type, data-type, database
The value of this tag appears to be misspelled. Please double-check.

ghc-neither-devel.x86_64: W: spelling-error %description -l en_US mtl -> mt, ml, mel
The value of this tag appears to be misspelled. Please double-check.

ghc-neither-devel.x86_64: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
The value of this tag appears to be misspelled. Please double-check.

ghc-neither-devel.x86_64: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
The value of this tag appears to be misspelled. Please double-check.

ghc-neither-prof.x86_64: E: devel-dependency ghc-neither-devel
Your package has a dependency on a devel package but it's not a devel package
itself.

ghc-neither-prof.x86_64: W: spelling-error %description -l en_US datatype -> data type, data-type, database
The value of this tag appears to be misspelled. Please double-check.

ghc-neither-prof.x86_64: W: spelling-error %description -l en_US mtl -> mt, ml, mel
The value of this tag appears to be misspelled. Please double-check.

ghc-neither-prof.x86_64: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
The value of this tag appears to be misspelled. Please double-check.

ghc-neither-prof.x86_64: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
The value of this tag appears to be misspelled. Please double-check.

ghc-neither-prof.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

ghc-neither-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.12.3/neither-0.1.0/libHSneither-0.1.0_p.a
A development file (usually source code) is located in a non-devel package. If
you want to include source code in your package, be sure to create a
development package.

ghc-neither.src: W: spelling-error %description -l en_US datatype -> data type, data-type, database
The value of this tag appears to be misspelled. Please double-check.

ghc-neither.src: W: spelling-error %description -l en_US mtl -> mt, ml, mel
The value of this tag appears to be misspelled. Please double-check.

ghc-neither.src: W: spelling-error %description -l en_US datatypes -> data types, data-types, databases
The value of this tag appears to be misspelled. Please double-check.

ghc-neither.src: W: spelling-error %description -l en_US AEither -> A Either, Aether, Either
The value of this tag appears to be misspelled. Please double-check.

ghc-neither.src: W: strange-permission ghc-neither.spec 0640L
A file that you listed to include in your package has strange permissions.
Usually, a file should have 0644 permissions.

ghc-neither.src: W: strange-permission neither-0.1.0.tar.gz 0640L
A file that you listed to include in your package has strange permissions.
Usually, a file should have 0644 permissions.

4 packages and 1 specfiles checked; 1 errors, 20 warnings.

[+]MUST: The package must be named according to the Package Naming Guidelines.
[+]MUST: The spec file name must match the base package %{name}, in the format %{name}.spec
[+]MUST: The package must meet the Packaging Guidelines.
        Naming-Yes
        Version-release - Matches
        License - OK, BSD 2 clause variant
        No prebuilt external bits - OK
        Spec legibity - OK
        Package template - OK
        Arch support - OK
        Libexecdir - OK
        rpmlint - yes
        changelogs - OK
        Source url tag  - OK, validated.
        Buildroot is ignored - present anyway. OK
        %clean is ignored - present anyway. OK
        Build Requires list - OK
        Summary and description - OK
        API documentation - OK, present in -devel package

[+]MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
    BSD 2-clause variant

[+]MUST: The License field in the package spec file must match the actual license.
[+]MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
Yes present in base package

[+]MUST: The spec file must be written in American English.
[+]MUST: The spec file for the package MUST be legible.
[+]MUST: The sources used to build the package must match the upstream source,as provided in the spec URL. Reviewers should use md5sum for this task.

[~/ghc-neither-0.1.0-1.fc14.src]$ md5sum neither-0.1.0.tar.gz 
539cae64246195aeb04d52223dbc4ded  neither-0.1.0.tar.gz

[~/ghc-neither-0.1.0-1.fc14.src]$ md5sum ~/Downloads/neither-0.1.0.tar.gz 
539cae64246195aeb04d52223dbc4ded  /home/narasimhan/Downloads/neither-0.1.0.tar.gz

[+]MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
Yes built on x86_64.

[+]MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in
ExcludeArch.
[+]MUST: All build dependencies must be listed in BuildRequires.
[NA]MUST: The spec file MUST handle locales properly using the %find_lang macro
[NA]MUST: Packages stores shared library files must call ldconfig in %post and %postun.
[+]MUST: Packages must NOT bundle copies of system libraries.
[NA]MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review.
[+]MUST: A package must own all directories that it creates.
[+]MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
[+]MUST: Permissions on files must be set properly.
[+]MUST: Each package must consistently use macros.
[+]MUST: The package must contain code, or permissable content.

[+]MUST: Large documentation files must go in a -doc subpackage.
API documentation in -devel package

[+]MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[+]MUST: Header files must be in a -devel package.
[NA]MUST: Static libraries must be in a -static package.
[NA]MUST: If a package contains library files with a suffix (e.g.libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[+]MUST: devel packages must require the base package using a fully versioned dependency: Requires: {name} = %{version}-%{release}
[NA]MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[NA]MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section
[+]MUST: Packages must not own files or directories already owned by other packages.
[+]MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+]MUST: All filenames in rpm packages must be valid UTF-8.

Should items
[+]SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[+]SHOULD: The reviewer should test that the package functions as described.
Installed on x86_64.
[+]SHOULD: If scriptlets are used, those scriptlets must be sane.

cabal2spec-diff is OK.

APPROVED.
Comment 4 Narasimhan 2010-11-21 11:19:56 EST
Will set the fedora-review flag once ghc-failure is approved.
Comment 5 Ben Boeckel 2010-12-05 12:40:21 EST
New Package CVS Request
=======================
Package Name: ghc-neither
Short Description: Either with monad and applicative instances
Owners: mathstuf
Branches: F-13 F-14
InitialCC: haskell-sig
Comment 6 Jason Tibbitts 2010-12-06 10:57:45 EST
Git done (by process-git-requests).
Comment 7 Fedora Update System 2010-12-10 20:45:21 EST
ghc-failure-0.1.0.1-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/ghc-failure-0.1.0.1-1.fc14
Comment 8 Fedora Update System 2010-12-10 20:45:28 EST
ghc-failure-0.1.0.1-1.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/ghc-failure-0.1.0.1-1.fc13
Comment 9 Fedora Update System 2010-12-11 19:03:45 EST
ghc-failure-0.1.0.1-1.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update ghc-failure'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/ghc-failure-0.1.0.1-1.fc13
Comment 10 Ben Boeckel 2010-12-11 19:25:29 EST
Heh. Oops. Put the wrong bug number for the update. Once ghc-failure gets a build override, it'll go in the same update.
Comment 11 Fedora Update System 2011-01-03 15:01:46 EST
ghc-neither-0.1.0-1.fc13, ghc-failure-0.1.0.1-1.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 12 Fedora Update System 2011-01-03 15:09:13 EST
ghc-neither-0.1.0-1.fc14, ghc-failure-0.1.0.1-1.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 Jens Petersen 2012-02-07 04:45:14 EST
(This was needed for persistent 0.3.*.)

Note You need to log in before you can comment on or make changes to this bug.